﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DEOCIOAPP.DEOCIO_WS;

namespace DEOCIOAPP.Forms
{
    public partial class SubCategories : Form
    {
        public SubCategories()
        {
            InitializeComponent();
            FillSubcategoriesGrid();

            label10.Parent = pictureBox1;
            label10.BackColor = Color.Transparent;
        }

        private void SubCategories_Load(object sender, EventArgs e)
        {

        }

        private void FillSubcategoriesGrid()
        {

            Models.Products DataContextProducts = new Models.Products();
            dtProductSubCategory[] SC = DataContextProducts.ProductSubCategory_GetAll();

            grdCategories.Rows.Clear();
            foreach (dtProductSubCategory C in SC)
            {
                string[] content = new string[] { "false", C.ProductSubCategoryId.ToString(), C.Name };

                grdCategories.Rows.Add(content);
            }

        
        }

        private void btnActualizar_Click(object sender, EventArgs e)
        {
            FillSubcategoriesGrid();
        }

        private void btnModificar_Click(object sender, EventArgs e)
        {
            int seleccionados = 0;

            string IDMod = "";
            string NombreMod = "";

            foreach (DataGridViewRow row in grdCategories.Rows)
            {
                if ((row.Cells[1].Size.IsEmpty) || (row.Cells[1].Value == null))
                {
                    continue;
                }
                else
                {
                    if (row.Cells[0].Value.Equals(true))
                    {
                        if (seleccionados == 0)
                        {
                            seleccionados = 1;
                            IDMod = row.Cells[1].Value.ToString();
                            NombreMod = row.Cells[2].Value.ToString();
                        }
                        else
                        {
                            seleccionados = 2;
                            MessageBox.Show("Seleccione solo un registro para modificarlo", "ATENCIÓN", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            return;
                        }
                    }
                }
            }

            if (seleccionados == 1)
            {
                txtId.Text = IDMod;
                txtNombre.Text = NombreMod;
                grdCategories.Enabled = false;
                btnModificar.Enabled = false;
                btnActualizar.Enabled = false;
            }
        }

        private void btnGuardar_Click(object sender, EventArgs e)
        {
            if (txtNombre.Text.Trim() == "")
            {
                MessageBox.Show("El campo categoría no puede estar en blanco.", "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (txtId.Text.Trim() != "")
            {
                Models.Products DataContextProducts = new Models.Products();
                string result = DataContextProducts.ProductSubCategory_Update(Convert.ToInt32(txtId.Text.Trim()), txtNombre.Text.Trim());
                MessageBox.Show(result, "Resultado", MessageBoxButtons.OK, MessageBoxIcon.Information);
                grdCategories.Enabled = true;
                btnModificar.Enabled = true;
                btnActualizar.Enabled = true;
                txtId.Text = "";
                txtNombre.Text ="";
                FillSubcategoriesGrid();
            }
            else
            {
                Models.Products DataContextProducts = new Models.Products();
                string result = DataContextProducts.ProductSubCategory_Insert(txtNombre.Text.Trim());
                MessageBox.Show(result, "Resultado", MessageBoxButtons.OK, MessageBoxIcon.Information);
                grdCategories.Enabled = true;
                btnModificar.Enabled = true;
                btnActualizar.Enabled = true;
                txtId.Text = "";
                txtNombre.Text = "";
                FillSubcategoriesGrid();
            }
        }

        private void btnEliminar_Click(object sender, EventArgs e)
        {
             DialogResult status = MessageBox.Show("Desea eliminar las categorías seleccionadas?", "Atención", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (status.ToString() == "Yes")
            {
                foreach (DataGridViewRow row in grdCategories.Rows)
                {
                    if ((row.Cells[1].Size.IsEmpty) || (row.Cells[1].Value == null))
                    {
                        continue;
                    }
                    else
                    {
                        if (row.Cells[0].Value.Equals(true))
                        {
                            Models.Products DataContextProducts = new Models.Products();
                            string result = DataContextProducts.ProductSubCategory_Delete(Convert.ToInt32(row.Cells[1].Value));
                            MessageBox.Show(result, "Resultado", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        }
                    }
                }
                FillSubcategoriesGrid();
            }
        }

        private void btnCancelar_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
