﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using DEOCIOAPP.Forms;

namespace DEOCIOAPP
{
    public partial class Main : Form
    {
        Login _login = new Login();

        public Main()
        {
            InitializeComponent();
            _login.ShowDialog();
            if (_login.Authenticated)
            {
                if (_login.role < 9)
                {
                    usuariosToolStripMenuItem.Enabled = false;
                }

            }
            else
            {
                MessageBox.Show("El usuario no se ha validado correctamente.");
                Application.Exit();
            }
        }

        private void crearOfertaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (CerrarTodos())
            {
                AddOffers NewForm = new AddOffers();
                NewForm.MdiParent = this;
                NewForm.Show();
            }
        }

        private void salirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (CerrarTodos())
            {
                Application.Exit();
            }
        }

        private void consultarOfertasToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (CerrarTodos())
            {
                ListOffers NewForm = new ListOffers();
                NewForm.MdiParent = this;
                NewForm.Show();
            }
        }

        private void listarUsuariosToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (CerrarTodos())
            {
                ListUsers NewForm = new ListUsers();
                NewForm.MdiParent = this;
                NewForm.Show();
            }

        }

        private void añadirUsuarioToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (CerrarTodos())
            {
                AddUser NewForm = new AddUser();
                NewForm.MdiParent = this;
                NewForm.Show();
            }
        }

        private void envíoDeCorreosToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (CerrarTodos())
            {
                SendMail NewForm = new SendMail();
                NewForm.MdiParent = this;
                NewForm.Show();
            }
        }

        private void categoríasToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (CerrarTodos())
            {
                SubCategories NewForm = new SubCategories();
                NewForm.MdiParent = this;
                NewForm.Show();
            }
        }

        private void listarPedidosToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (CerrarTodos())
            {
                ListOrders NewForm = new ListOrders();
                NewForm.MdiParent = this;
                NewForm.Show();
            }
        }

        private bool CerrarTodos()
        {
            DialogResult status = new DialogResult();

            foreach (Form aForm in this.MdiChildren)
            {
                if (status.ToString() == "None") status = MessageBox.Show("Se cerraran todos los formularios abiertos. Desea continuar?", "ATENCIÓN", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (status.ToString() == "Yes")
                {
                        aForm.Close();
                }
                else return false;
            }
            return true;
        }

        private void ofertasToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

       

    }
}
