﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ReportManagement;
using DEOCIO.Models;
using System.Web.Routing;

// Controlador Pdf
namespace DEOCIO.Controllers
{
    public class PdfController : PdfViewController
    {
        // Definimos los servicios para interactuar con el modelo de datos
        public ProductService ProductServices;
        public IMembershipService MembershipService { get; set; }

        protected override void Initialize(RequestContext requestContext)
        {
            // Inicializamos los servicios.
            if (ProductServices == null) { ProductServices = new ProductModels(); }
            if (MembershipService == null) { MembershipService = new AccountMembershipService(); }
            base.Initialize(requestContext);
        }

        //**************************************************************************
        //Nombre: CreatePdf()
        //Descripción: Genera un PDF de la orden de compra pasada por parámetro.
        //@params [int OfferId]
        //**************************************************************************
        public ActionResult CreatePdf(string SalesId)
        {
            int IdSales = Convert.ToInt32(SalesId);
            ConfirmationBuy CB = ProductServices.getCommandInfo(IdSales);
            // devuelve la vista como PDF.
            return this.ViewPdf("DEOCIO.ES", "CreatePdf", CB);
        }
    }
}
