﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using DEOCIO.DataModel.Customers;
using DEOCIO.DataModel.TablasMaestras.msStateProvince;
using DEOCIO.Models;
using DEOCIO.DataModel.TablasMaestras.msRoles;
using DEOCIO.DataModel.Products;

namespace DEOCIO
{
    [ServiceContract]
    public interface IDEOCIO_WS
    {
        // Se definene los contratos del Servicio Web DEOCIO_WS

        [OperationContract]
        string ValidateUser(string Email, string password);

        [OperationContract]
        bool AddProduct(ProductModel PM);

        [OperationContract]
        List<ProductModel> GetOffers(string Name, string ProductNumber, string ShortDesc, int? ProductCategory);

        [OperationContract]
        string DeleteOffer(int ProductId);

        [OperationContract]
        List<msStateProvince> GetProvinces();

        [OperationContract]
        ProductModel GetProductOnlyById(int ProductID);

        [OperationContract]
        dtCustomer_RecoveryAllResult[] RecoveryAllCustomers(string firstName, string middleName, string lastName, string dNI, string email, int? role);

        [OperationContract]
        msRole[] GetAllUserRoles();

        [OperationContract]
        string AddUser(string sufijo, string name, string primerapellido, string segundoapellido,
                       string dni, string email, string password, string direccion, string cp, string poblacion,
                       string provincia, string telefono, string movil, bool contrato, bool recibirinfo, int role, IEnumerable<int> categorias);

        [OperationContract]
        string DelCustomer(int CustomerId);

        [OperationContract]
        string UpdateStatusAccount(int CustomerId, int StatusAccount);

        [OperationContract]
        dtProductSubCategory[] ProductSubCategory_GetAll();
        
        [OperationContract]
        string ProductSubCategory_Delete(int ProductSubcategoryId);
        
        [OperationContract]
        string ProductSubCategory_Update(int ProductSubcategoryId, string Name);
        
        [OperationContract]
        string ProductSubCategory_Insert(string Name);

        [OperationContract]
        bool SendEmail(string destination, string Header, string Text);

        [OperationContract]
        bool SendOffersByPreference();

        [OperationContract]
        CommandInfo[] GetAllOrders(int? SalesOrderID, DateTime? OrderDate, string ProductShortDesc, int? ProductSubcategoryID, string ProductNumber, string Email, string DNI);
        
        [OperationContract]
        string RecoveryPassword(string email);

        [OperationContract]
        string UpdateProductStatus(int ProductID, int Status);

        [OperationContract]
        CustomerDataInfo RecoveryCustomerDataInfoById(int IdCustomer);

        [OperationContract]
        CustomerDataInfo UpdateCustomerInfo(CustomerDataInfo Customer);

        [OperationContract]
        CommandInfo[] GetOrderById(int OrderId);

        [OperationContract]
        ProductModel UpdateProducts(ProductModel PM);
    }
}
