﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DEOCIO.DataModel.Products;

// Modelo de datos comun.
namespace DEOCIO.Models
{
    #region Models

    // Clase OrderBy utilizada como modelo de datos en el combo "Ordenar Por".
    public class OrderBy
        {
            public string Value { get; set; }
            public string Text { get; set; }
        }

    #endregion
    #region Services

    //**************************************************************************
    //Nombre: CommonService()
    //Descripción: Se definen las interfícies que contendrá el servicio
    //@params [None]
    //@return [None]
    //**************************************************************************
    public interface CommonService
        {
        // Obtener los valores 
        List<OrderBy> getOrderByList();
        }


    public class CommonModels : CommonService
    {

        //**************************************************************************
        //Nombre: getOrderByList()
        //Descripción: Obtiene los valores del combo OrdenarPor.
        //@params [None]
        //@return [None]
        //**************************************************************************
       public List<OrderBy> getOrderByList()
        {
           List<OrderBy> GOB = new List<OrderBy>();
            
           OrderBy OP = new OrderBy();
           OP.Value="OfferPrice";
           OP.Text = "Precio más bajo";
           GOB.Add(OP);

           OrderBy OV = new OrderBy();
           OV.Value = "Votes";
           OV.Text = "Mayor pupularidad";
           GOB.Add(OV);

           OrderBy OX = new OrderBy();
           OX.Value = "Proximity";
           OX.Text = "Proximidad";
           GOB.Add(OX);
           
           return GOB;
        }
    }
        #endregion


}
